#ifndef NUS_BASE_H
#define NUS_BASE_H

// $Id: NUS_Base.h,v 1.1 2006/08/10 17:16:01 nicholas Exp $

#include "NUS_MapObject.h"
#include "GameObj.H"

namespace NUS_Simul{

	const real8 NUS_BASE_SIZE_DIVISOR=10.0;

	class Base : public MapObject{

	public:
		Base(GameObj* obj, uint4 playerID, uint4 hp);
		Base(GameObj*, uint4 playerID);

		Base* clone() const;

		bool withinRange(Group* otherObject);

		real8 getHitPoints() const { return hitPoints;}

		void setHitPoints(real8 hitPoints){
			this->hitPoints = hitPoints;
			recalculateExtents();
		}

		void recalculateExtents() {  extents = (sqrt(hitPoints)/NUS_BASE_SIZE_DIVISOR);}

		real8 getExtents() const {return extents;}

		GameObj *getObject() { return gameObj; }

		GameObj *gameObj;

		real8 hitPoints;

		real8 extents;
	private:
	};
}
#endif
