#ifndef NUS_STRATEGIES_H
#define NUS_STRATEGIES_H

// $Id: NUS_Strategies.h,v 1.1 2006/08/10 17:16:02 nicholas Exp $

#include "NUS_Task.h"

#define DECLARE_TASK(name)						\
  class name : public Task{						\
  public:								\
    name(uint4 playerID,SimulationState* state,GroupVector& groupVector,	\
	 TaskCreateFunctionPtr f,std::string name,real8 timeout,MoveStruct* extraData = NULL); \
    name(Task* parent,GroupVector& groupVector,TaskCreateFunctionPtr function,std::string name, \
	 real8 timeout, MoveStruct* extraData = NULL); \
    name(const name&);							\
    Task* clone(SimulationState* state, Task* parent);			\
    bool exec();							\
  }

namespace NUS_Simul {
  class SimulationState;

  //DECLARE_TASK(MassAttack);
  DECLARE_TASK(SpreadAttack);
  //DECLARE_TASK(HalfUnitsBaseDefence_MassAttack);

  // internal tasks, don't use these explicitly right now

  DECLARE_TASK(Join);
  DECLARE_TASK(Attack);
  DECLARE_TASK(MoveToLocation);
  //DECLARE_TASK(MoveToObject);
  //DECLARE_TASK(DefendObject);
  //DECLARE_TASK(TouchObj);
  DECLARE_TASK(JoinAndMoveToObj);
  DECLARE_TASK(SmartJoin);
  DECLARE_TASK(Hunter);
  DECLARE_TASK(Hunter2);
  DECLARE_TASK(Hunter3);
  DECLARE_TASK(JoinAndHunt);
  DECLARE_TASK(JoinAndHunt2);
  DECLARE_TASK(JoinAndHunt3);
  DECLARE_TASK(JoinSpreadAttack);
  DECLARE_TASK(JoinAndAttack);
  DECLARE_TASK(TravoAttack);

// these declarations are only needed for the very highest level tasks

//Task* createMassAttack_unitsFirst(uint4 id,SimulationState* s,GroupVector& g);
//Task* createSpreadAttack_baseFirst(uint4 id,SimulationState* s,GroupVector& g);
  Task* createSpreadAttack(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createMassAttack(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createHalfUnitsBaseDefence_MassAttack(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createHunter(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createHunter2(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createHunter3(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createJoinSpreadAttack(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  Task* createTravoAttack(uint4 id,SimulationState* s,GroupVector& o,real8 timeout);
  
  NUS_TerrainBase::Loc find_a_spot(NUS_TerrainBase::Loc center_loc, GameStateModule& gsm, SimulationState* state);
  // NOTE: maybe make these available to be made explicitly instead of just being made by the above tasks, not now though
  /*
    Task* createJoin();
    Task* createAttack();
    Task* createMove();
  */

  // FIXME any better way to do this?  a dynamic size?
  const uint4 NUM_STRATEGIES = 3;
  const TaskCreateFunctionPtr strategyList[] = {
    NULL,
    /*createMassAttack,*/
    createSpreadAttack,
    /*createHalfUnitsBaseDefence_MassAttack,*/
    createHunter,
    createHunter2/*,
	createHunter3,
    createSpreadAttack*/
  };

}
#endif

