#ifndef NUS_UNIT_H
#define NUS_UNIT_H

// $Id: NUS_Unit.h,v 1.1 2006/08/10 17:16:02 nicholas Exp $
#include "Global.H"

#include "NUS_TerrainBase.H"
#include "GameObj.H"

#include "NUS_Base.h"

#include <string>
#include <sstream>

namespace NUS_Simul{

  class Unit{
  public:

    Unit();
    Unit(GameObj* obj,real8 hp, NUS_TerrainBase::Loc pos);
	Unit(GameObj* obj);
	
	Unit(const Unit &);
	Unit* clone() const;
	
    double getHitPoints(){return hitPoints;}
    NUS_TerrainBase::Loc getPosition() {return position;}
    GameObj* getObject() { return obj;}

	real8 distance_to(NUS_TerrainBase::Loc &loc) const {
		return sqrt(square(real8(position.x-loc.x)) + square(real8(position.y-loc.y)));		
	}
	
	real8 distance_to(GameObj *obj) const {
		return sqrt(square(real8(position.x-obj->get_int("x"))) + square(real8(position.y-obj->get_int("y"))));		
	}
	
	real8 distance_to(Unit &u) const {
		return sqrt(square(real8(position.x-u.position.x)) + square(real8(position.y-u.position.y)));
	}
	
	real8 distance_to(Base &b) const {
		Vector3D pos = b.getPosition();
		real8 extents = b.getExtents();
		Vector3D test(position.x, position.y, 0.0);
		Vector3D loc(position.x, position.y, 0.0);
		
		if(test.x < (pos.x - extents/2.0)) test.x = pos.x - extents/2.0;

		if(test.x > (pos.x + extents/2.0)) test.x = pos.x + extents/2.0;

		if(test.y < (pos.y - extents/2.0)) test.y = pos.y - extents/2.0;

		if(test.y > (pos.y + extents/2.0)) test.y = pos.y + extents/2.0;

		return (loc - test).length();
	}

    double hitPoints;
    NUS_TerrainBase::Loc position;
    GameObj* obj;

	NUS_TerrainBase::Loc steering;
	bool pushed;
	
  private:
  };
}
#endif

