#ifndef GAITank_H
#define GAITank_H

#include "Game.H"
#include "aStarLibrary.H"
#include "GameStateModule.H"
#include "GfxModule.H"
#include "GameChanges.H"
#include "GameTile.H"
#include "ServerObjData.H"
#include "Options.H"

class GAITank
{
  public:
    GAITank() {};
    GAITank(GameObj* tanky, int idee);
    bool act(const Game& game);
    int getID();
    ScalarPoint getPosition();
    void move(int x, int y);
    void moveSelf(int x, int y);
    void init();
    void setGoal(int x, int y);
    bool goalReached();
    bool temporaryGoalReached();
    void setFormation(int x, int y);
    ScalarPoint getFormation();
    GameObj* tank;
    ScalarPoint UnwalkableTile, WalkableTile;
    void moveSelfWOPathfinding(int x, int y, int speed);
    ScalarPoint temporaryGoal;
    bool tempGoalSet;
    int standStill;
    void attackWeakestInRange(const Game& game, GameObj* target);
    GameObj* weakestInRange(const Game& game, int enemyID, double multiplier);	
    void attackControlInRange(const Game& game, int enemyID);
    bool isAttacking();

  private:
    aStarLibrary* pathfinder;
    bool attacking;
    int ID;
    int TileWalkable(const GameTile &tile);
    ScalarPoint getTileCoor(int x, int y);
    bool firstTime;
    ScalarPoint lastPosition, from, goaly;
    ScalarPoint formation;
};

#endif
