#ifndef LoadAI_H
#define LoadAI_H

// $Id: LowAI.H,v 1.3 2006/08/05 22:20:10 orts_mburo Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// low-level AI abstract interface

#include "Global.H"

class GameStateModule;
class GameObj;

template <class Data> class LowAI {

public:

  // compute actions for all objects
  virtual void act(GameStateModule &gsm) = 0;

  // add object to collection
  virtual void add(GameObj *gob) {
    obj2dat[gob] = Data();
  }

  // delete object from collection
  virtual void del(GameObj *gob) { obj2dat.erase(gob); }

  virtual ~LowAI() {}
  
  std::map<GameObj*, Data> obj2dat;
};

#endif
