// $Id: TurretAI.C,v 1.11 2006/08/31 16:56:50 dtom Exp $

// This is an ORTS file (c) Michael Buro, licensed under the GPL

// turret "ai": attack everything within range

#include "TurretAI.H"
#include "GameStateModule.H"
#include "Game.H"
#include "GameObj.H"

using namespace std;

const std::string TurretAI::bp_name = "turret";

// attack closest air object

// fixme: improve

void TurretAI::act(GameStateModule &gsm)
{
  Game &game = gsm.get_game();
  //sint4 me = game.get_client_player();

  // cout << "turret_ai " << obj2dat.size() << " turret(s)" << endl;

  FORALL (obj2dat, it) {
  
    GameObj *min_gob = 0;
    real8 min_d = max_sint4;

    sint4 x0 = *it->first->sod.x;
    sint4 y0 = *it->first->sod.y;

    const sint4 attack_d = square(it->first->component("weapon2")->get_int("range")); 
    
    FORU (i, game.get_player_num()) {  // fixme: also i==game.get_player_num() (neutral)?
      
      const Game::ObjCont &objs = game.get_objs(i);
      
      FORALL (objs, it2) {
        GameObj *gob = (*it2)->get_GameObj();
        if (!gob || *gob->sod.zcat != Object::IN_AIR) continue;

        sint4 x = *gob->sod.x;
        sint4 y = *gob->sod.y;    
        sint4 d = square(x - x0) + square(y - y0);

        if (d != 0 && d < min_d) { // fixme: d == 0 happens even though no unit on top of pad?!

          //cout << d << " " << attack_d << " " << x << " " << y << " : " << x0 << " " << y0 << endl;
          min_d = d; min_gob = gob;
        }
      }
    }

    if (min_d <= attack_d) {

      // fixme: observe cooldown
      
      //cout << "launch " << sqrt(min_d) << " " << sqrt(attack_d) << endl;
      Vector<sint4> args;
      args.push_back(game.get_cplayer_info().get_id(min_gob));
      it->first->component("weapon")->set_action("attack", args);
    }
  }
}
