/** @page scriptcode Script Code Description

- @ref scriptcodeoverview
  - @ref scriptfunctions
  - @ref gamefunctions
  - @ref clientfunctions
- @ref actionexecution

@section scriptcodeoverview Overview

@subsection scriptfunctions Script Functions

@subsection gamefunctions Game Script Functions

- enable(obj)                        Game::script_GOB_Enable
- disable(obj)                       Game::script_GOB_Disable
- enabled(obj)                       Game::script_GOB_Is_Enabled

- printnum(int)                      Game::script_printnum
- cout("formatting string", p1, p2, ...)        Game::script_cout

- tick()                             Game::script_Tick

- distance(obj, obj)                 Game::script_Distance
- notify_attack(obj, obj, damage)    Game::script_Notify_Attack
- kill(obj)                          Game::script_GOB_Kill
- alive(obj)                         Game::script_GOB_Is_Alive
- typeof(obj)                        Game::script_GOB_Type
- type2name(int)                     Game::script_GOB_Type2Name
- visible_by(obj, int)               Game::script_GOB_Visible_By
- cancel(obj; "action_name")         Game::script_GOB_Cancel_Action
- has_attr(obj; "attr_name")         Game::script_GOB_Has_Attr
- get_attr(obj; "attr_name")         Game::script_GOB_Get_Attr
- get_comp(obj; "comp_name")         Game::script_GOB_Get_Comp

- eval(...)                          Game::script_eval
- close_to(obj, obj, int)            Game::script_close_to

- create("obj_name", owner)          Game::script_GOB_Create
- create_id(obj_id, owner)           Game::script_GOB_CreateId
- move(obj; x, y, [speed])           Game::script_GOB_Move
- position(obj)                      Game::script_GOB_Fix_Position
- can_see(obj, obj)                  Game::script_GOB_Can_See
- footprint(obj, vector)             Game::script_GOB_Footprint

- get_tile(?)                        Game::script_get_tile_type
- set_tile(?)                        Game::script_set_tile_type

- map_width()                        Game::script_map_width
- map_height()                       Game::script_map_height

- sqrt(int)                          Game::script_sqrt

- end_game(winner)                   Game::script_end_game
- save_game()                        Game::script_save_game

@subsection clientfunctions Client Script Functions

- psin(deg, multiplier)              GUI_psin
- pcos(deg, multiplier)              GUI_pcos
- atan2(dx, dy)                      GUI_atan2
- set_cursor(int)                    GUI_set_cursor
- ERR("formatting string", p1, p2, ...) GUI_error

- strcmp("s1", "s2")                 GUI_strcmp
- printf(x, y, "formatting string", p1, p2, ...)    GUI_printf
- draw_text(x, y, "string")          GUI_text
- draw_textf(x, y, "string", font)   GUI_textf
- set_color(r, g, b, a)              GUI_Color
- draw_bitmap(x, y, w, h, bitmap)    GUI_Bitmap
- draw_rect(x, y, w, h)              GUI_Rect

- draw_overlay(obj; tex, x, y, w, h) GfxModule::GUI_Overlay
- start_overlay(obj)                 GfxModule::GUI_start_overlay
- end_overlay()                      GfxModule::GUI_end_overlay
- draw_model(obj, x, y, size)        GfxModule::GUI_DrawModel2D

- create_view()                      GfxModule::GUI_CreateView
- resize_view(id, x, y, w, h)        GfxModule::GUI_ResizeView
- delete_view(id)                    GfxModule::GUI_DeleteView

- screen2world(x, y, vector)         GfxModule::GUI_Screen2World
- screen2obj(x, y)                   GfxModule::GUI_Screen2Obj
- deselect_obj(id)                   GfxModule::GUI_Deselect_obj
- minimap_pos(x, y, w, h)            GfxModule::GUI_MinimapPos

- get_val("attr")                    GfxModule::GUI_Get_DBVal
- set_val("attr", val)               GfxModule::GUI_Set_DBVal
- get_vec("attr", vector)            GfxModule::GUI_Get_DBVec
- set_vec("attr", vector)            GfxModule::GUI_Set_DBVec

- flatten_terrain(obj)               GfxModule::GUI_FlattenTerrain
- unflatten_terrain(obj)             GfxModule::GUI_UnFlattenTerrain
- show_grid(yn)                      GUI_Outline
- mark_tiles(vector, r, g ,b)        GfxModule::GUI_MarkTiles
- unmark_tiles(id)                   GfxModule::GUI_UnmarkTiles
- mark_rect(r, g, b, x0, y0, y1, y1) GfxModule::GUI_MarkRect
- edit_rect(id, r, g, b, x0, y0, y1, y1)  GfxModule::GUI_EditRect
- unmark_rect(id)                    GfxModule::GUI_UnmarkRect

- quit_game()                        GfxModule::GUI_quitGame
- toggle_pf(yn)                      GfxModule::GUI_toggle_pathfinding

- load_bp("filename.bp")             GfxModule::GUI_LoadBP

- load_sound("sound.wav")            GfxModule::GUI_load_sound
- play_sound(id, ...)                GfxModule::GUI_play_sound

- broadcast(...)                     GfxModule::GUI_broadcast


@section actionexecution Action Execution

*/
