/*
    (c) Michael Buro, mic@research.nj.nec.com
    NEC Research Institute
    4 Independence Way
    Princeton, NJ 08540, USA

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef Client_H
#define Client_H

// generic client (only I/O)

#include "Global.H"
#include "String.H"
#include "SocketBuffer.H"

class Client {

public:

  String host;
  sint4 port;
  SocketBuffer sb;

  Client(sint4 ibl=32768, sint4 obl=32768) : sb(ibl, obl) { port = -1; }

  void close();
  bool is_closed() const;
  sint4 socket() const { return sb.my_socket; }
  
  // true <=> blocked
  sint4 write_msg(const string &msg, bool blocking);
  sint4 write_flush();
  sint4 read_msg(string &msg);
  sint4 write_line(const string &s, bool blocking);
  sint4 read_char(char &c, bool blocking);
  sint4 read_msg2(string &msg, bool ready);

  // false iff OK
  virtual bool connect(const char *host_, sint4 port_);
  virtual ~Client();
};

#endif
